function loginUser(url,data)
{
								
	var success = false;				
	$.ajax({
		url: url,
		type: "POST",
		data:data,
		headers: {
			"source":"plugins",
			"Content-Type":"application/json"
		},								
		error: function(jqXHR, textStatus, errorThrown){							
			
			showLoginErr('<span>error: </span>Invalid username or password. Please try again.');	
		},
		success: function(data){
			
			setDefaultHeaders(data.userSchemas,data.schema,data["api-token"]);
			initializeCompanies(data.companiesNames,data.companyId);
			setLoginCookie(data);
			loadProjects();
			
					
		}
	});
	
}

function setDefaultHeaders(userSchemas,schema,apiToken){
	
	// Set cid 
	for(var key in userSchemas)
	{
		if(userSchemas[key]==schema)
		{
			cid=key;
		}
	}
	
	// Set api token 
	
	token = apiToken;
	
	

}

function loadCompanies(url, username, signature)
{
	console.log('Loading Companies...');										
	var success = false;				
	$.ajax({
		url: url,
		type: "POST",
		headers: {
			"source" : "plugins",
			"signature" : signature,
			"userid" : username,
			"timestamp" : "123",
			"schema" : schema
		},								
		error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while Loading Companies: ' + errorThrown);
			showLoginErr('<span>error: </span>Invalid username or password. Please try again.');						
		},
		success: function(data){
			
			packageType = data.package_type;
			$(".div-us").show();
			if(packageType=='null')
			{
				console.log("Package Service not applicable");
				$("#usr_story").show();
				$("#dd-sprints").show();
				$("#usr_story2").show();
				$("#sprintDiv").show();
			}
			else if(packageType == "agile"){
				$("#usr_story").show();
				$("#usr_story2").show();
				$("#dd-sprints").show();
			}			
			else{
				$("#d-steps").show();
				$("#usr_story").hide();
				$("#usr_story2").hide();
				$("#dd-sprints").hide();
				$("#d-severity").show();
				$("#usr_story").hide();
				$("#usr_story2").hide();
				$("#sprintDiv").hide();
				$("#usr_story2").removeClass("check");
				$("#usr_story").removeClass("check");
				$("#bg-label").addClass("check");
				$("#bg-label-new").addClass("check");
				search_sel="bug";
				
			}
			console.log(packageType);
			companies_response = data;	
			success = true;						
			un_exists = true;
			sign_exists = true;
	
			initializeCompanies(data.companies);												
			initializeUsers(data.users);
			initializeSeverities(data.severity);
																							
			if(!success)
			{
				showLoginErr('<span>error: </span>Invalid username or password. Please try again.');				
			}
			else
			{
				console.log('Companies Loaded Successfully!');
				loadProjects();				
			}
		}		
	});															
}	
function loadProjects()
{

	$.ajax({
		url: URL_Prefix + "/api/rest/projects/",
		type: "GET",
		headers: {
			"token"	:	token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		success: function(data){										
						
			initializeProjects(data);
			var _pid = $("#dd-project").val();
			loadSprints(_pid);			
		},
		error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while Loading Projects: ' + errorThrown);	
			showLogin();
		}		
	});										
}	
function loadSprints(pid)
{
	
	$.ajax({
		url: URL_Prefix + "/api/rest/projects/"+pid+"/sprints",
		type: "GET",
		headers: {
			"token"	:	token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		success: function(data)
		{
				
			initializeSprints(data);
			loadReleases(pid);			
		},
		error: function(jqXHR, textStatus, errorThrown){							

			if(jqXHR.responseText=="no sprint exist in project id :"+pid)
			{
				
				loadReleases(pid);
			}
		}
	});
}
function loadReleases(pid)
{
	


	$.ajax({
		url: URL_Prefix + "/api/rest/projects/"+pid+"/releases",
		type: "POST",
		headers: {
			"token"	:	token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},					
		success: function(data){			
							
			initializeReleases(data);	
			loadUserMetaData(pid);
		},
		error: function(jqXHR, textStatus, errorThrown){							
			if(jqXHR.responseText=="no release exist in project id :"+pid)
			{
				loadUserMetaData(pid);
				
			}			
		}
	});		
}
function loadUserMetaData(pid)
{
	
	$.ajax({
		url: URL_Prefix + "/api/rest/user/meta",
		type: "GET",
		headers: {
			"token"	:	token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		success: function(data){			
			initPackageType(data);
			initializeSeverities(data.severity)
			initializeLoggedInUser(data.user);
			loadProjectMetaData(pid)
		
			
		},		
		error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while Loading user/meta: ' + errorThrown);			
		}
	});										
}

function loadProjectMetaData(pid)
{
	
	$.ajax({
		url: URL_Prefix + "/api/rest/projects/"+pid+"/meta/",
		type: "GET",
		headers: {
			"token"	:	token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		success: function(data){			
				
	
			initializeUsers(data.users);
			loadTags(pid);
			
			
		},		
		error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while Loading ProjectMetaData: ' + errorThrown);		
			loadTags(pid);
		}
	});										
}

function loadTags(pid){
	
	
	$.ajax({
		url: URL_Prefix + "/api/rest/projects/"+pid+"/tags",
		type: "GET",
		headers:{
			"token":token,
			"key":cid,
			"Content-Type":"application/json"
		},
		error: function(errorThrown){
			console.log('Error occurred while Loading tags: ' + errorThrown);
			loadVersion()
			showUpload();	
			$("#footer").hide();
		},
		success: function(response){
			initializeTags(response);
			loadVersion()
			showUpload();	
			$("#footer").hide();
		}
	});
	
	
}

function loadVersion(){
	console.log("Loading version!");	
	var currentVersion = "";
	Components.utils.import("resource://gre/modules/AddonManager.jsm");
	AddonManager.getAddonByID("yodiz@viztrend.com", function(addon) {
			currentVersion =  addon.version
	    });
	
	$.ajax({
		url: URL_Prefix+"/api/rest/projects/fireFox/version",
		type: "GET",
		success: function(data){
			
			if(data == "null"){
				return ;
			}
			
			version = 	data;
			if(version != currentVersion){
				$(".updateus").show();
				$(".updateus").html("New Version is available ,  <a target='_blank' href='http://yodiz.com/help/?p=2073 ' > Download here </a> ");
			}
			
		},		
		error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while Loading Version: ' + errorThrown);			
		}
	});
}


function initializeTags(tags){

	try{

		allTags = "";
		allTags=tags;
		allTags = filterTagCategory(allTags);
		$('#tags').tagit({

			allowSpaces: true,
			maxLength : 50 ,
			caseSensitive: (false),
			allowSpaces : (true) ,
			placeholderText: "Add tags here  ",
			tagLimit : (15),

			autocomplete: {
				source: allTags,
				minLength: 1,
				create: function () {
					//access to jQuery Autocomplete widget differs depending    uiAutocomplete
					//on jQuery UI version - you can also try .data('autocomplete')
					$(this).data('uiAutocomplete')._renderMenu = customRenderMenu;
				}},
				beforeTagAdded: function(event, ui) {
					// Check in case of new tag ...
					var tagObj = _.findWhere(allTags, { title: String(ui.tagLabel)});
					if(tagObj == undefined){
						addTag(ui.tagLabel);  // add tag to server db ..
						var tag = {id:null , title:ui.tagLabel,label:ui.tagLabel ,value:ui.tagLabel,category:"Standard"};
						allTags.push(tag);
					}
				},
				preprocessTag : function(val){
					return val.substring(0,50);
				},
				onTagLimitExceeded :function (event, ui){
					$('#tag-err-msg').show();
					$('#tag-err-msg').delay(2000).fadeOut(500);
				}    ,
				afterTagAdded:function (event,ui){
					var tagVal= ui.tagLabel;
					var tagObject = _.findWhere(allTags, {value: tagVal});
					if(tagObject != undefined && tagObject.category != undefined){
						if(tagObject.category == "Special"){
							$('.tagit-choice:last').addClass('spTag');
						}
					}
				}
		});


	}catch(e){
		console.log(e);
	}


}

function initializeCompanies(companies,company_id)
{
	try
	{

		var html = "";
		for(var key in companies)
		{
			if(companies.hasOwnProperty(key))
			{
				html += '<option value="' + key + '" >' + companies[key] + '</option>';
			}
		}

		$("#dd-companies").html(html);
		$("#dd-companiesNew").html(html);
		companyId=company_id;
		$("#dd-companies").val(cid);
		$("#dd-companiesNew").val(cid);

	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the companies. Please contact Yodiz support.');						
	}	
}

function initializeSeverities(severity)
{
	try
	{
		if(severity != undefined)
		{
			severity_obj = severity;
			var html = '';
			for(var i = 0; i < severity.length; i++)
			{
				severity[i].narrative = severity[i].narrative.replace(/[^a-zA-Z0-9]/g,' ');	
				html += '<option value="' + severity[i].code + '" >' + severity[i].narrative + '</option>';
			}
			$("#dd-severity").html(html);						
			$("#dd-severity").val('err-svr-10');
		}
	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the severities. Please contact Yodiz support.');						
	}			
}
function initializeUsers(users)
{
	try
	{
		if(users != undefined)
		{
			users_obj = users;			
			var html = '<option value="0" >Select Responsible</option>';
			for(var i = 0; i < users.length; i++)
			{
							
				html += '<option value="' + users[i].id + '" >' + users[i].firstName + '  '+ users[i].lastName +'</option>';
			}
			$("#dd-responsible").html(html);						
		}
	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the users. Please contact Yodiz support.');						
	}	
}
function initializeProjects(projects)
{
	try
	{
		var temp = "";
		for(var i = 0; i < projects.length; i++)
		{
			pid = projects[0].id;
			projects[i].title = projects[i].title.replace(/[^a-zA-Z0-9]/g,' ');			
			temp =  temp + "<option value='" + projects[i].id + "' >" + projects[i].title + "</option>";
		}										
		$('#dd-project').html(temp);

			
	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the projects. Please contact Yodiz support.');						
	}
}
function initializeSprints(iteration)
{
	try
	{
		sid = 0;
		var html = '<option value="0" >Select Sprint</option>';						
		for(var i = 0; iteration != undefined && i < iteration.length; i++)
		{			
			iteration[i].title = iteration[i].title.replace(/[^a-zA-Z0-9]/g,' ');
			html += '<option value="' + iteration[i].id + '" >' + iteration[i].title + '</option>';
		}
		$("#dd-sprints").html(html);
		
				
	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the sprints. Please contact Yodiz support.');						
	}		
}
function initializeReleases(release)
{
	try
	{		
		rid = 0;
		var html = '<option value="0" >Select Release</option>';							
		for(var i = 0; release != undefined && i < release.length; i++)
		{						
			release[i].title = release[i].title.replace(/[^a-zA-Z0-9]/g,' ');	
			html += '<option value="' + release[i].id + '" >' + release[i].title + '</option>';			
		}		
		$("#dd-releases").html(html);	
		
		
	}
	catch(err)
	{												
		console.log(JSON.stringify(err));
		$("#dd-releases").html("<option>Select Release</option>");
	}		
}
function initializeLoggedInUser(user)
{
	try
	{
	
		// Logged In User 
		$("#logged-in-user").html("Welcome, " + user.firstName+" "+ user.lastName);	
		uid = user.id;
	}
	catch(err)
	{												
		console.log(err);
		showLoginErr('<span>error: </span>An unexpected error occurred while loading the releases. Please contact Yodiz support.');						
	}		
}

function changeCompany()
{
	console.log('Changing Company...');										
	var success = false;	
	$.ajax({
	url: URL_Prefix + "/integration/login",
	type: "GET",
	headers: {
		"source" : "plugins",
		"signature" : signature,
		"userid" : un,
		"timestamp" : "123",
		"schema":schema
	},								
	error: function(jqXHR, textStatus, errorThrown){							
		console.log('Error occurred while Logging In: ' + errorThrown);
		showLoginErr('<span>error: </span>Invalid username or password. Please try again.');	
	//	resetCookies();
	},
	success: function(data){
		console.log("Company changes Successfully");
		
		pid=data.projects[0].id;
		console.log(URL_Prefix + "/integration/projects/"+pid+"/app/meta");
		$.ajax({
			url: URL_Prefix + "/integration/projects/"+pid+"/app/meta",
			type: "POST",
			headers: {
			"source" : "plugins",
			"signature" : signature,
			"userid" : un,
			"timestamp" : "123",
			"schema" : schema				
			},
			error: function(jqXHR, textStatus, errorThrown){							
			console.log('Error occurred while retrieving Package Type ' + errorThrown);
			showLoginErr('<span>error: </span>Error occurred while retrieving Package Type. Please try again.');	
	//		resetCookies();
			},
			success: function(data){
				console.log("Package Type Retrieved Successfully");
				
				if(data.package_type=='null')
				{
					console.log("Package Service not applicable");
					$("#usr_story").show();
					$("#usr_story2").show();
					$("#sprintDiv").show();
					$("#dd-sprints").show();
					
				}
				else if(data.package_type!='agile')
				{
					console.log("Issue");
					$("#d-severity").show();
					$("#d-steps").show();
					$("#usr_story").hide();
					$("#usr_story2").hide();
					$("#sprintDiv").hide();
					$("#usr_story2").removeClass("check");
					$("#usr_story").removeClass("check");
					$("#bg-label").addClass("check");
					$("#bg-label-new").addClass("check");
					search_sel="bug";
				}
				else{
					console.log("Agile");
					$("#usr_story").show();
					$("#usr_story2").show();
					$("#sprintDiv").show();
					$("#dd-sprints").show();
				}
				loadProjects();
						
			}
		});
	}
	});
	
}


function onLoad()
{
	$("#my-image")[0].src = $("#display")[0].toDataURL();
	$("#ss-image2")[0].src= $("#display")[0].toDataURL();
	$("#ss-image")[0].src= $("#display")[0].toDataURL();
	$("#img-success")[0].src = 	$("#my-image")[0].src;
	$("#display").hide();
	$("#toolbar").hide();

	$("#div-auth").hide();
	$("#div-upload").hide();
	$("#upload-loader").show();
	$("#yodiz").show();
	
	resetForm();						
	setBrowserInfo();						
	checkCookie();			

	
	if(cid !="" && cid != undefined &&   token !="" && token != undefined){
		
		showUpload();
		$("#upload-loader").show();
		initializeCompanies(companies,companyId);
		loadProjects();
		
			
	}
	else
	{				
		showLogin();
	}						
}




function setBrowserInfo()
{
	var env = '';
	env += 'Browser: ' + navigator.userAgent;			
	$("#details").val(env);
	details_val = $("#details").val();
}
function resetForm()
{
	pid = "0";
	rid = "0";
	sid = "0";

	$("#us")[0].checked = false;
	$("#bg")[0].checked = true;

	//$("#dd-companies").html('<option value="0" >Select Organization</option>');
	$("#dd-projects").html('<option value="0" >Select Project</option>');
	$("#dd-releases").html('<option value="0" >Select Release</option>');
	$("#dd-sprints").html('<option value="0" >Select Sprint</option>');
	$("#dd-severity").html('<option value="0" >Select Severity</option>');
	$("#dd-responsible").html('<option value="0" >Select Responsible</option>');

	$("#upload-error").hide();
}
function showLogin()
{	
	$("#auth-loader").hide();
	$("#div-upload").hide();
	$("#auth-error").hide();
	$("#div-auth").show();

}
function showLoginErr(err_msg)
{
	$("#auth-error").html(err_msg);
	$("#auth-loader").hide();
	$("#div-upload").hide();
	$("#auth-error").show();
	$("#div-auth").show();
}
function showUpload()
{
	$("#div-auth").hide();
	$("#auth-loader").hide()
	$("#upload-loader").hide();			
	$("#auth-error").hide();
	$("#d-options").show();
	$("#div-upload").show();
	$("#signout").show();
	$("#logged-in-user").show();	

}
function hideError()
{
	$("#auth-error").html('');
	$("#auth-error").hide();	
}

function setItemProperties(){
	
	item = {} ;
	pid  = $("#dd-project").val();
	
	if(pid == "0" || pid =="")
	{
		$("#upload-error").html("Please Select any Project.");
		$("#upload-error").show();		
		return false;
	}
	
	var iid = $("#dd-sprints").val(); 
	
	if(iid != "0")
	{
		item.iteration = {} ; item.iteration.id = iid ;
	}
	
	var rid = $("#dd-releases").val(); 
	
	if(rid != "0")
	{
		item.release = {} ; item.release.id = rid ;
	}
	
	
	var title = $.trim($("#bug-title").val());	

	if(title.length == 0)
	{
		$("#upload-error").html("Please provide Title");
		$("#upload-error").show();			
		return false;				
	}
	else if(title.length > 250)
	{
			title = title.substring(0, 250);
	}
	title = title.replace(/\n/g,'<br>');
	title = title.replace(/\t/g,'    ');		
	title = title.replace(/"/g,'&quot;');
	title = String(title);
	item.title = title ;
	details_val = $.trim($("#details")[0].value);
	if(details_val.length >= 30000 )
	{
		details_val.substring(0, 30000);
	}
	details_val = details_val.replace(/\n/g, '<br>');					
	details_val = details_val.replace(/\t/g, '    ');									
	details_val = details_val.replace(/"/g, '&quot;');
	
	item.description = details_val ;
	
	var tags=$("#tags").val();
	
	if(tags !=undefined || tags !=""){
		item.tagStr = tags ;
	}
	
	
	
	var userId = $("#dd-responsible").val();
	
	
	if(sel == "us"){
		item.sequence = "0.0";
		item.status = {} ; item.status.code = "us-st-10";
		if(userId !="0"){
			item.owner = {} ;  item.owner.id = userId ; 
		}
		
		
	}
	else if(sel == "bug") {
		 
		steps_val = $.trim($("#steps")[0].value);
		if(steps_val.length >= 30000 )
		{
			steps_val.substring(0, 30000);
		}							
		steps_val = steps_val.replace(/\n/g,'<br>');					
		steps_val = steps_val.replace(/\t/g,'    ');			
		steps_val = steps_val.replace(/"/g,'&quot;');
		item.stepsToReproduce =steps_val;
		
		if(userId !="0"){
			item.responsible = {} ;  item.responsible.id = userId ; 
		}
		
		var severityCode =  $("#dd-severity").val();
		if(severityCode !="0"){
			item.severity =  {} ; item.severity.code = severityCode ; 
			
		}
		
		
	}
	
		return true;									
	

}

function uploadAttachment(){
	
	var timeStamp = new Date().getTime();
	var url_attach = URL_Prefix + "/api/rest/projects/"+pid+"/attachString"; 
	var data;
	var imageData = $('#my-image')[0].src;
	var itemTypeCode = "101_ERROR";
	if(sel=="us")
	{
		 itemTypeCode = "331_USER_STORY"; 
	}
	
	data = '{ "fname" : "screenshot-'+ timeStamp + '.png"' +'  , "ext" : "png" , "itemTypeCode" :"'+itemTypeCode+'", "attachmentString" : "' + imageData + '" }';
	
	$.ajax({		
		url: URL_Prefix + "/api/rest/projects/"+pid+"/attachString",
		type: "POST",
		data: data,
		headers: {
			"token": token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		error: function(errorThrown){
			$("#upload-error").html("Something went wrong. Please try again.");
			$("#upload-error").show();
			$("#upload-loader").hide();
		},
		success: function(response)
		{									
			
			//var imageObj=JSON.stringify(response);
			item.attachments = [] ;
			item.attachments.push(response);
			saveItem();
			
			
			
		
						
		}
	});	
	
}

function saveItem(){
	
	
	var URL = URL_Prefix + "/api/rest/projects/"+pid+"/issue/create";
	if(sel=="us")
	{
		URL = URL_Prefix + "/api/rest/projects/"+pid+"/us/create";
	}
	
	
	$.ajax({
		data:  JSON.stringify(item), 
		url: URL,
		type: "POST",							
		headers: {
			"token": token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},					
		error: function(errorThrown){				
			$("#upload-error").html("Something went wrong! . Please try again.");
			$("#upload-error").show();
			$("#upload-loader").hide();
			console.log(errorThrown.responseText);
			
		},
		success: function(response)
		{	
			item = response ;
			
			if(sel=="us")
			{
				$("#link")[0].href =  URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + item.id;
				$("#link").html("View at Yodiz");
				try
				{
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>US-"+ item.id  +"</strong>: " + item.title + "</a>" );
					$("#link-in-title")[0].href =   URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + item.id;							
				}
				catch(err){
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>US-"+ item.id  +"</strong>: " + "" + "</a>" );
					$("#link-in-title")[0].href =   URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + item.id;							
				}							
				$("#creation-msg").html("New User Story has been created successfully.");
			}else {
				
				var _url = URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + item.id;																						
				$("#link")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + item.id;									
				$("#link").html("View at Yodiz");
				try
				{
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>BG-"+ item.id  +"</strong>: " + item.title + "</a>" );							
					$("#link-in-title")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + item.id;									
				}
				catch(err){
					console.log(err);	
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>BG-"+ item.id  +"</strong>: " + "" + "</a>" );															
					$("#link-in-title")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + item.id;									
				}																					
				$("#creation-msg").html("New issue has been created successfully.");
			}
																					
																						
			$("#div-upload").hide();
			$("#div-welcome").show();							
			$("#upload-loader").hide();
		
		}
	});
	
	
}

function uploadAttachmentWithExistingItem(element){

	
	$("#upload-loader").show();
	$("#bugResults").hide();
	$("#searchbar").hide();
	$("#find-search").hide();	
	$("#dd-search").hide();
	
	
	var itemId =  $(element).attr("data-itemId");
	searchname = unescape($(element).attr("data-Title"));

	
	
	var timeStamp = new Date().getTime();
	var data;
	var imageData = $('#my-image')[0].src;
	var itemTypeCode = "101_ERROR";
	if(search_sel=="us")
	{
		 itemTypeCode = "331_USER_STORY"; 
	}
	
	data = '{ "fname" : "screenshot-'+ timeStamp + '.png"' +'  , "ext" : "png" , "itemTypeCode" :"'+itemTypeCode+'", "attachmentString" : "' + imageData + '" , "itemId":"'+itemId+'" }';
	
	$.ajax({		
		url: URL_Prefix + "/api/rest/projects/"+pid+"/attachment/item",
		type: "POST",
		data: data,
		headers: {
			"token": token,
			"key"	:	cid,
			"Content-Type"	:	"application/json"
		},
		error: function(errorThrown){
			$("#upload-loader").hide();
		},
		success: function(response)
		{		
			
			 
			if(search_sel=="bug")
			{
				var _url = URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + itemId;																						
				$("#link")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + itemId;
				try
				{
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>BG-"+ itemId  +"</strong> </a> "+searchname+"" );							
					$("#link-in-title")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + itemId;									
				}
				catch(err){
					console.log(err);	
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>BG-"+ itemId  +"</strong>: " + "" + "</a>" );															
					$("#link-in-title")[0].href =  URL_Prefix + "/bug/pages/bug.vz?cid=" + companyId + "&pid=" + pid + "&id=" + itemId;									
				} 
			
				$("#creation-msg").html("screenshot attached to existing Issue.");
			}else {
				
				$("#link")[0].href =  URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + itemId;
				
				try
				{
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>US-"+ itemId  +"</strong>: " +searchname + "</a>" );
					$("#link-in-title")[0].href =   URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + itemId;							
				}
				catch(err){
					$("#entity-details").html("<a id=\"link-in-title\" target=\"_blank\"><strong>US-"+ entityId  +"</strong>: " + "" + "</a>" );
					$("#link-in-title")[0].href =   URL_Prefix + "/plan/pages/user-story.vz?cid=" + companyId + "&pid=" + pid + "&usid=" + itemId;							
				}
				$("#creation-msg").html("screenshot attached to existing User Story.");
			}
		
			
			$("#div-upload").hide();
			$("#div-welcome").show(); 	 	
			$("#upload-loader").hide();
			
			
		
						
		}
	});
	
	
}


function filterTagCategory(tags){

    for(var i = 0; i < tags.length ; i++){
        tags[i].category = "Standard";
        tags[i].label = tags[i].title;
        tags[i].value = tags[i].title;
        if(tags[i].isSystemTag != undefined ){
            if(tags[i].isSystemTag==true){
                tags[i].category =	"Special";
            }
        }
    }
    tags=  tags.sort(sortTagByCategory);
    return tags;

}

function sortTagByCategory(a, b){
	return ((a.category < b.category) ? -1 : ((a.category > b.category) ? 1 : 0));
}

var customRenderMenu = function(ul, items){
    var self = this;
    var category = null;


    $.each(items, function (index, item) {
        if (item.category != category) {
            category = item.category;
            if(category == "Special"){

                ul.append("<li class='special' ><h4>" + category + "</h4></li>");
            }

            if(category == "Standard"){
                ul.append("<li class='standard'><h4>" + category + "</h4></li>");
            }

        }
        self._renderItemData(ul, item);
    });
};


function addTag(newTag)
{
	var attach_tag='{"title":"'+newTag+'"}';
	console.log(attach_tag);
	$.ajax({
		url: URL_Prefix + "/api/rest/projects/tag/create",
		type: "POST",
		data: attach_tag,
		headers:{
			"token":token,
			"key":cid,
			"Content-Type":"application/json"
		},
		success:function(res){
			console.log(res);
		},
		error:function(err){
						
			console.log(err);	
		}
		
	});
}

function setLoginCookie(data){
	
	cookieSvc.setCookieString(uri, null, "cid=" + cid + ";" + " expires=" + exdate.toUTCString(), null);			
	cookieSvc.setCookieString(uri, null, "token=" + token + ";"  + " expires=" + exdate.toUTCString() , null);
	cookieSvc.setCookieString(uri, null, "companyId=" + data.companyId + ";"  + " expires=" + exdate.toUTCString() , null);
	cookieSvc.setCookieString(uri, null, "companies=" + JSON.stringify(data.companiesNames) + ";"  + " expires=" + exdate.toUTCString() , null);
	cookieSvc.setCookieString(uri, null, "signout="+false + ";" + " expires=" + exdate.toUTCString() , null);
	
	
	
}

function fetchCompanyKey(key){
	
	$.ajax({
		url: URL_Prefix + "/api/rest/user/"+key+"/decpt",
		type: "POST",
		data: '{"key":"private-yodiz"}',
		headers:{
			"token":token,
			"key":cid,
			"Content-Type":"application/json"
		},
		success:function(res){
			companyId = res;
			cookieSvc.setCookieString(uri, null, "companyId=" + companyId+ ";"  + " expires=" + exdate.toUTCString() , null);
		},
		error:function(err){
			console.log(err);			
					
		}
		
	});
};



function initPackageType(data){
	
	
	if(data.package_type ==  undefined)
	{
		console.log("Package Service not applicable");
		$("#usr_story").show();
		$("#usr_story2").show();
		$("#sprintDiv").show();
		$("#dd-sprints").show();
		
	}
	else if(data.package_type!='agile')
	{
		console.log("Issue");
		$("#d-severity").show();
		$("#d-steps").show();
		$("#usr_story").hide();
		$("#usr_story2").hide();
		$("#sprintDiv").hide();
		$("#usr_story2").removeClass("check");
		$("#usr_story").removeClass("check");
		$("#bg-label").addClass("check");
		$("#bg-label-new").addClass("check");
		search_sel="bug";
	}
	else{
		console.log("Agile");
		$("#usr_story").show();
		$("#usr_story2").show();
		$("#sprintDiv").show();
		$("#dd-sprints").show();
	}
	
}